#include "read_spline_AC1014.h"
#include <core/variable.h>
#include <iostream>
#include <fstream>
#include <string>
#include <algorithm>
using namespace std;
#include <to_rgba.h>

void read_spline_AC1014::spline(wxString filename)
{
    //http://help.autodesk.com/view/ACD/2015/ENU/?guid=GUID-E1F884F8-AA90-4864-A215-3182D47A9C74
    unsigned int linenumber;
    unsigned int layer_line;
    unsigned int color_line;
    unsigned int x_line;
    unsigned int y_line;
    unsigned int z_line;
    bool trigger=0;
    double x;
    double y;
    double z;
    unsigned int color;
    string line;
    string layer;

    ifstream infile;
    infile.open (filename);
        while(!infile.eof()) // To get you all the lines.
        {
            getline(infile,line); // Saves the line in STRING.

            if(line=="SPLINE"){
                cout<<"spline found"<<endl;
                trigger=1;
            }

            if(trigger && line==" 62"){
                color_line=linenumber+1;
            }
            if(trigger && linenumber==color_line){
                //cout<<cad_counter<<" x:"<<line<<endl;
                color=stoi(line);
            }

            if(trigger && line==" 8"){
                layer_line=linenumber+1;
            }
            if(trigger && linenumber==layer_line){
                //cout<<cad_counter<<" x:"<<line<<endl;
                layer=line;
            }

            if(trigger && line==" 11"){
                x_line=linenumber+1;
            }
            if(trigger && linenumber==x_line){
                //cout<<cad_counter<<" x:"<<line<<endl;
                x=stod(line);
            }

            if(trigger && line==" 21"){
                y_line=linenumber+1;
            }
            if(trigger && linenumber==y_line){
                //cout<<cad_counter<<" y:"<<line<<endl;
                y=stod(line);
            }

            if(trigger && line==" 31"){
                z_line=linenumber+1;
            }
            if(trigger && linenumber==z_line){
                //cout<<cad_counter<<" y:"<<line<<endl;
                z=stod(line);

                SCAD[cad_counter][0]=layer;
                ICAD[cad_counter][0]=5;     //id
                ICAD[cad_counter][2]=color;
                to_rgba().rgba(cad_counter,color);
                DCAD[cad_counter][0]=x;
                DCAD[cad_counter][1]=y;
                DCAD[cad_counter][2]=z;
                cad_counter++;
            }

            if(trigger && line=="  0"){
                trigger=0;
                ICAD[cad_counter-1][1]=1; //id=flag stop
                //cout<<cad_counter-1<<" spline end:"<<endl;
            }
            linenumber++;
        }
    infile.close();
}
